
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

include 'include/function.inc'
include 'include/math.inc'
include 'include/collection.inc'
include 'include/export_list.inc'
include 'include/flags.inc'
include 'include/init.inc'
include 'include/copy_structures.inc'
include 'include/internal_structures.inc'
include 'include/save_restore_data.inc'
include 'include/bind.inc'
include 'include/general_exports.inc'
include 'include/listen.inc'
include 'include/handle_connection.inc'
include 'include/control_panel_exports.inc'

currentLoadingModule pointer 0
modules pointer 0 ;A linked-list of loaded modules
protocols pointer 0 ;A linked-list of loaded protocols
listenSessions pointer 0 ;A indexed-collection, indexed by the listensession
clientSessions pointer 0 ;A indexed-collection, indexed by the listensession
highestReservedListenSessionId pointer 0   ;the highest reserved, not yet released, ListensessionId

registerdProtocolIsLoadedFunctions pointer 0 ;A collection with pointers to ProtocolIsLoaded functions that need to be called when a new
registerdListenSessionIsCreatedFunctions pointer 0 ;A collection with pointers to ListenSessionIsCreated functions that need to be called when a new

;start routine
Start:
if used is32
  ;do systemcheck (W 9x or NT)
  call doSystemCheck
end if

;call setExceptionHandler  ;=> only used during development
call getCommandLine

;find the end of the string
mov pedi,peax ;(R/E)DI => pointer to ASCII string
xor ecx,ecx   ; zero ECX
dec pecx      ; (R/E)CX => -1  (scasb will be repeated for 0xFFFFFFFF(FFFFFFFF) times, or until zero byte is found)
xor eax,eax   ; byte to find with scasb => '\0'

repnz scasb   ;loop string until zero byte is found

;check if size commadline is <2
add pecx,2
jc noCommandLineGiven

mov ax,word [pedi-3] ;get 2 last bytes of the commandline

push 0		 ;parameter for exitProcess
push exitProcess ;return address

cmp ax,'-i' ;Install service
je InstallService

cmp ax,'-u' ;Uninstall service
je UninstallService

cmp ax,'-s' ;Stop service
je StopService

add pesp,psize*2 ;remove exitProcess and parameter from stack

cmp ax,'-b' ;boot as user  (no service)
je RunWithoutService

noCommandLineGiven:
call CheckAndStartService
test eax,eax
jnz _endprocess

RunWithoutService:
call StartServices

quit:
endThread
ret

_endprocess:
push 0
call exitProcess

;------------------------------------------------------------------------------
;This function will start all services
;
;
;input:
;       none
;output:none
;------------------------------------------------------------------------------
StartServices:
call PrepareSaveToDisk

call CreateCollection
mov [listenSessions],peax

call CreateCollection
mov [clientSessions],peax

call CreateCollection
mov [registerdProtocolIsLoadedFunctions],peax

call CreateCollection
mov [registerdListenSessionIsCreatedFunctions],peax

;load modules
push 0			    ;no param
push CallbackLoadModules    ;callback function
push 0			    ;no subKey
push 0			    ;no subKey
push 0			    ;no subKey
push subkeyMudules	    ;subKey
push pdword [hKey]	    ;hkey
call EnumRegValue

;load lsitensessions
push quit
jmp LoadListenSessionsFromDisk
ret

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegValue and will fill in the
;item[] member of the structure Row
;
;input:
;       1:hKey
;       2:param  (pointer to Row structure)
;       3:valueName
;       4:value
;       5:valueSize
;       6:valueType
;output: EAX: true / false
;------------------------------------------------------------------------------
CallbackLoadModules:
call denter
MakeStack

;check if the type is a string
cmp pdword [pebp+psize*7],REG_SZ
jne endCallbackLoadModules

;load the plugin
push 0x1 ;NOT_SAFE_ON_DISK
push pdword [pebp+psize*5]
call loadPlugin

endCallbackLoadModules:
call dleave
ret psize*6

;------------------------------------------------------------------------------
;This function sets error code from eax/rax to the psess param
;------------------------------------------------------------------------------
setLastError:
push pecx
;set lastError member
mov pecx,pdword [pebp+(psize*2)]
mov dword [pecx+(psize*2)],eax

;if eax>0 then eax=0, if eax=0 then eax=1
xor ecx,ecx
STC
rcr ecx,1
dec eax
and eax,ecx
rol eax,1
pop pecx
ret


errorTitle db 'error',0
errorMessage db 'Could not load the libaray.. closing',0