
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

;FreeInternalClientStructure This function will free the members and the InternalClientStructure itself
;FindNextOrPreviousPsess / FindNextOrPreviousPsessEx This function will find the next psess (or previous) with internal structure from the Bindedto member
;deleteRowStructureWithGarbageCollection This function will delete a Row structure with a GarbageCollection at the end
;FreeListenSession/FreeClientSession This function will free the members and the Listensession itself
;FreeInternalListenStructure This function will free the members and the InternalListenStructure itself
;CreateInternalListenStructure This function will create a mem location to a InternalListenStructure
;CreateListBindedTohandleListFromBindStruct: This function will free the members and the InternalListenStructure itself
;addToLinkedList: This function will add one item to a linked list
;CreateInternalProtocolStructure: This function will create a mem location to a InternalProtocolSession structure
;getInternalModuleStructure:This function will get the module structure from the module handle
;getInternalProtocolStructure:This function will get the internalProtocolStructure from the ProtocolSession
;compairAndGetStructure:This function will compare a value in the structure of a linked list to find an item
;checkProtocolSession: This function is internal and will check if the pointer psess exists and finds it's internal structure
;checkListenSession:This function is internal and will check if the pointer lsess exists and finds it's internal structure
;addToGarbageFromListenSession: This function will add pointer with type to the carbage collection from a ListenSession
;addToGarbage: This function will add pointer with type to the carbage collection
;disposeGarbage: This function will remove every pointer in the carbageCollection in a proper way
;removeInternalRowCollection: This function will remove an internal row collection

;------------------------------------------------------------------------------
;This function will delete a Row structure with a GarbageCollection at the end
;input:
;       1:Row strucuture
;output: EAX: true / false
;------------------------------------------------------------------------------
deleteRowStructureWithGarbageCollection:
call denter

mov pebx,pdword [pebp+psize*2] ;get Row strucuture
test pebx,pebx
jz endDeleteRowStructureWithGarbageCollection

mov esi,dword [pebx]	       ;size member
mov pesi,pdword [pesi+pebx]    ;get pointer to the garbageCollection
mov pedi,pesi		       ;make a copy of the pointer from the GarbageCollection

lodsp		;get size member of the GarbageCollection
mov pecx,peax	;(R/E)CX = size of the GarbageCollection
if used is32
  shr pecx,3	  ;divide by 4 (to get the ammount of pointers)
else
  shr pecx,3	  ;divide by 8 (to get the ammount of pointers)
end if
jecxz noPointersToDelete

deletePointers:
  lodsp 		   ;get pointer from the GarbageCollection
  push peax
  call FreeMemLocation	   ;delete the pointer
loop deletePointers

noPointersToDelete:
;delete the GarbageCollection
push pedi
call FreeMemLocation

;delete the Row structure
push pebx
call FreeMemLocation

endDeleteRowStructureWithGarbageCollection:
call dleave
ret psize

;------------------------------------------------------------------------------
;This function will create a new unique identifir for a listensession (but will not lock the list, you'l have to do it yourself)
;input:
;  none
;output: new unique Id
;------------------------------------------------------------------------------
getNewlistenSessionsId:
call denter

;lock the list so no one can reserve the same unique Id as we do
push FULL_LOCK
push [listenSessions] ;Collection
call LockListAcces

mov pedx,[highestReservedListenSessionId]
inc pedx

;get items in the ListenSession list
restartGetNewlistenSessionsId:
push [listenSessions]
call CountItems
mov ecx,eax
jecxz endGetNewlistenSessionsId
shr ecx,1 ;ECX = ECC / 2

loopItems:
  mov eax,ecx
  shl eax,1 ;EAX = EAX * 2

  push peax
  push [listenSessions]
  call GetDwordItem
  test eax,eax
  jz nextListenSessionItem

  cmp edx,dword [peax+(5*psize)+4]  ;'id' param
  jne nextListenSessionItem

  inc edx
  jmp restartGetNewlistenSessionsId

nextListenSessionItem:
  loop loopItems

endGetNewlistenSessionsId:
cmp pedx,[highestReservedListenSessionId]
jb currentIdNotHighestId

  mov [highestReservedListenSessionId],pedx

currentIdNotHighestId:
;unlock the list
push FULL_LOCK
push [listenSessions] ;Collection
call ExternalUnlockListAccesEx

mov eax,edx ;the new unique Id
call dleave
ret

;------------------------------------------------------------------------------
;This function will remove the highestId if they are the same. This needs to be called afther the Internal ListenSession is placed in the list ListenSessions
;input:
;  1:id
;output: new unique Id
;------------------------------------------------------------------------------
releaseHighestListenSessionsId:
call denter

mov peax,[highestReservedListenSessionId]
xor ecx,ecx
lock cmpxchg [highestReservedListenSessionId],pecx

call dleave
ret psize

;------------------------------------------------------------------------------
;This function will free the members and the InternalClientStructure itself
;input:
;  1:InternalClientStructure
;output: true/false
;------------------------------------------------------------------------------
FreeInternalClientStructure:
call denter

mov pebx,pdword [pebp+psize*2] ;InternalClientStructure

;free member BindedTohandle
push pdword [pebx]
call FreeDwordCollection

;free member dataByPsessByInteger
if used isLinux
  mov peax,FreeIndexedCollection
  push peax
else
  push FreeIndexedCollection
end if
push USE_FREE_ITEM_FUNCTION or REMOVE_INDEX_LIST
push pdword [pebx+psize*3]
call FreeCollectionEx

;free member dataByPsessByName
if used isLinux
  mov peax,FreeIndexedCollectionWithItemCollections
  push peax
else
  push FreeIndexedCollectionWithItemCollections
end if
push USE_FREE_ITEM_FUNCTION or REMOVE_INDEX_LIST
push pdword [pebx+psize*4]
call FreeCollectionEx

;remove the  garbageCollection and everything in it
push pdword [pebx+(psize*5)+8]
call disposeGarbage

;free the InternalListenStructure
push pebx
call FreeCallerMemLocation;

xor eax,eax
inc eax

call dleave
ret psize

;------------------------------------------------------------------------------
;Changes from FindNextOrPreviousPsessEx:
;   - the (R/E)DI register is resotred (so pointer to Internal ProtocolStructure is not leaked out)
;   - Input:
;       EBP+8 or RBP+10 (instead of (R/E)DX: psess is current psess
;-----------------------------------------------------------------------------
FindNextOrPreviousPsess:
push pedi

mov pedx,pdword [pebp+psize*2]
call FindNextOrPreviousPsessEx

pop pedi
ret


;------------------------------------------------------------------------------
;This function will find the next psess (or previous) with internal structure from the Bindedto member
;input:
;  (R/E)AX: Internal Client or Listensession
;  (R/E)DX: current psess
;  ECX: flags:
;       0x0 increment psess
;       0x1 decrement psess
;
;return:
;  (R/E)SI: Next PSESS
;  (R/E)DX: modstruct (of the psess)
;  (R/E)DI: Internal ProtocolStructure
;  (R/E)CX: BindedTohandle
;  (R/E)AX: 0:Error 1:Found next or previous psess 2:no more psess
;-----------------------------------------------------------------------------
FindNextOrPreviousPsessEx:
mov pedi,pdword [peax] ;BindedTohandle

;Lock the list so no other threads can use it
push FULL_LOCK
push pedi
call LockListAcces

;find the index of psess in the BindedTohandle list
push pedx
push pedi
call FindDword
test eax,eax
jz errFindNextOrPreviousPsess

;get previous psess handle
mov edx,eax
dec edx

;get next psess handle
inc eax

test ecx,0x1
cmovnz eax,edx

push peax
push pedi
call GetDwordItem

xor esi,esi
add esi,2

test peax,peax
cmovz peax,pesi   ;There are no more protocols to bind to, return 2
jz errFindNextOrPreviousPsess
mov pesi,peax				;Set the next psess on (R/E)SI

;--Unlock the list
push FULL_LOCK
push pedi
call ExternalUnlockListAccesEx

;get internal protocol session
push pesi
call getInternalProtocolStructure
mov pecx,pedi	;(R/E)CX = BindedTohandle
mov pedi,peax	;Set internal ProtocolStructure
test peax,peax
jz endFindNextOrPreviousPsess

;get modstruct on EDX, on 64-bit systems this value will be set by argpush 2, that's why we use r12 in 64 bit
if used is64
  mov r12,pdword [peax+psize*4]
else
  mov pedx,pdword [peax+psize*4]
end if

xor eax,eax
inc eax

endFindNextOrPreviousPsess:
ret


errFindNextOrPreviousPsess:
push peax

;--Unlock:
push FULL_LOCK
push pedi
call ExternalUnlockListAccesEx

pop peax
jmp endFindNextOrPreviousPsess

;------------------------------------------------------------------------------
;This function create a InternalClientSession from a InternalListenSession
;input:
;  1:InternalListenStructure
;  2:lsess
;output: pointer to InternalClientSession
;------------------------------------------------------------------------------
CreateInternalClientSessionFromInternalListenStructure:
call denter

push SIZEOF_INTERNALCLIENTSESSION
call GetMemLocation
mov pebx,peax

;create list for BindedTohandle member

mov pesi,pdword [pebp+psize*2]
push pdword [pesi]     ;push InternalListenStructure ->BindedTohandle
call copyDwordList     ;<----This should be virtualMemory!!!!!!!!!!!!!!
mov pdword [pebx],peax ;fill in BindedTohandle member

;set bindedToLsess
mov peax,pdword [pebp+psize*3]
mov pdword [pebx+psize*1],peax

;fill in dataByPsessByInteger member
call CreateCollection
mov pdword [pebx+psize*3],peax
mov pedi,peax

;fill in  dataByPsessByName member
call CreateCollection
mov pdword [pebx+psize*4],peax
mov pedx,peax

;fill in  garbageCollection member
call CreateCollection
mov pdword [pebx+(psize*5)+8],peax

;get InternalListenStructure ->BindedTohandle
mov pesi,pdword [pebp+psize*2]
mov pesi,pdword [pesi]

push pesi
call CountItems
mov ecx,eax

loopBindedTohandleMember:
  ;get the psess from InternalListenStructure ->BindedTohandle
  push pecx
  push pesi
  call GetDwordItem

  ;r13 = psess OR [esp]=psess
  if used is64
    mov r13,peax
  else
    push peax
  end if

  call CreateCollection

  ;push psess on InternalClientStructure ->BindedTohandle
  push ADD_POINTER
  push 0
  push peax		     ;item  (new collection)
  if used is32
    push dword [esp+0xC]      ;index (psess)
  else
    push r13		      ;index (psess)
  end if
  push pedi		     ;dataByPsessByInteger
  call AddIndexedItemEx

  call CreateCollection

  ;push psess on InternalClientStructure ->BindedTohandle
  push ADD_POINTER
  push 0
  push peax		     ;item  (new collection)
  if used is32
    push dword [esp+0xC]     ;index (psess)
  else
    push r13		     ;index (psess)
  end if
  push pedx		    ;dataByPsessByInteger
  call AddIndexedItemEx

  if used is32
    add esp,0x4 ;remove psess from stack
  end if

loop loopBindedTohandleMember

mov peax,pebx

call dleave
ret psize*2

;------------------------------------------------------------------------------
;This function will free the members and the Listensession itself
;input:
;  1:ExternalListenStructure
;output: true/false
;------------------------------------------------------------------------------
FreeClientSession:
FreeListenSession:
call denter

mov pebx,pdword [pebp+psize*2] ;ListenSession
test pebx,pebx
je endFreeListenSession

mov pecx,pdword [pebx+4*2]	;ProtocolData
jecxz dontFreeProtocolData

push pecx
call FreeCallerMemLocation

dontFreeProtocolData:
push pebx
call FreeCallerMemLocation

endFreeListenSession:
call dleave
ret psize

;------------------------------------------------------------------------------
;This function will free the members and the InternalListenStructure itself
;input:
;  1:InternalListenStructure
;output: true/false
;------------------------------------------------------------------------------
FreeInternalListenStructure:
call denter

mov pebx,pdword [pebp+psize*2] ;InternalListenStructure

;free member BindedTohandle
push pdword [pebx]
call FreeDwordCollection

;free member copyLsess
push pdword [pebx+psize]
call FreeListenSession

;free member dataByPsessByInteger
if used isLinux
  mov peax,FreeIndexedCollection
  push peax
else
  push FreeIndexedCollection
end if
push USE_FREE_ITEM_FUNCTION or REMOVE_INDEX_LIST
push pdword [pebx+psize*3]
call FreeCollectionEx

;free member dataByPsessByName
if used isLinux
  mov peax,FreeIndexedCollectionWithItemCollections
  push peax
else
  push FreeIndexedCollectionWithItemCollections
end if
push USE_FREE_ITEM_FUNCTION or REMOVE_INDEX_LIST
push pdword [pebx+psize*4]
call FreeCollectionEx

;remove the  garbageCollection and everything in it
push pdword [pebx+(psize*5)+8]
call disposeGarbage

;free the InternalListenStructure
push pebx
call FreeMemLocation

xor eax,eax
inc eax

call dleave
ret psize

;------------------------------------------------------------------------------
;This function will create a mem location to a InternalListenStructure (renember, the uniqueId is not released)
;input:
;  1:BindStruct
;  2:UniqueId
;  3:name
;output: Pointer to InternalListenStructure
;------------------------------------------------------------------------------
CreateInternalListenStructure:
call denter

push SIZEOF_INTERNALLISTENSESSION
call GetMemLocation
mov pebx,peax

mov peax,pdword [pebp+psize*3]
test peax,peax
jnz setId

call getNewlistenSessionsId

setId:
mov dword [pebx+(5*psize)+4],eax ;set unique Id in the internal session

;cope the name
push pdword [pebp+psize*4]
call copyStringA
mov pdword [pebx+(5*psize)+8+psize],peax ;fill in the ListenSession name

;create list for BindedTohandle member
call CreateCollection	 ;<----This should be virtualMemory!!!!!!!!!!!!!!
mov pdword [pebx],peax ;fill in BindedTohandle member
mov pesi,peax

;(R/E)DX = BindStruct
mov pedx,pdword [pebp+psize*2]

;fill in dataByPsessByInteger member
call CreateCollection
mov pdword [pebx+psize*3],peax
mov pedi,peax

;fill in  garbageCollection member
call CreateCollection
mov pdword [pebx+(psize*5)+8],peax

;fill in  dataByPsessByName member
call CreateCollection
mov pdword [pebx+psize*4],peax

;Create a list of ProtocolData structures and fills in the lists
push pedi  ;in/output: list that needs to be filled with other lists, with index psess
push peax  ;in/output: list that needs to be filled with other lists, with index psess
push pesi  ;in/output: list that need to filled with psess values
push pedx  ;input: BindStruct
call CreateListBindedTohandleListFromBindStruct
test peax,peax
jz errCreateInternalListenStructure

;Create listen session  with
push peax      ;data member
call CreateListenSession

;fill in the copyLsess param
mov pdword [pebx+psize],peax


mov pesi,pdword [pesi] ;Get array of binded psess
lodsp		       ;Get ammount of items
mov pecx,peax	       ;ECX = ammount of items

loopBindendPsess:
  lodsp
  if used is64
    mov r12,rax 			 ;R12 = psess
  end if

  if used is64
    mov r13d,ecx			 ;save counter
  else
    push ecx				 ;save counter
  end if

  mov pedi,pdword [pedx+psize+8+psize]	 ;Get initOptions
  mov pedx,pdword [pedx+psize+8]	 ;next BindStruct

  test pedi,pedi
  jz nextLoopBindendPsess		 ;jump if there is no initOptions

  mov ecx,dword [pedi]			 ;get size of structure
  sub ecx,8				 ;substract member size and flags
  if used is32
    shr ecx,4				 ;ECX = ECX / 16 (16 bytes is one BindInitOption structure)
  else
    mov r14,rdx 			 ;save rdx

    ;divide by 24 (24 bytes is one BindInitOption structure)
    xor edx,edx
    mov eax,ecx
    mov ecx,24
    div ecx
    mov rcx,rax

    mov rdx,r14 			 ;restore rdx
  end if

  add pedi,8				 ;Skip to first BindInitOption structure
  call loopInitOptions

nextLoopBindendPsess:
  if used is64
    mov ecx,r13d			 ;restore counter
  else
    pop ecx				 ;restore counter
  end if

  dec pecx
jnz loopBindendPsess

endLoopBindendPsess:

mov peax,pebx

;return
endCreateInternalListenStructure:
call dleave
ret psize*3;----*2

;Err
errCreateInternalListenStructure:
;release BindedTohandle
push pdword [pebx]
call FreeCollection

;release dataByPsessByInteger
push pdword [pebx+psize*3]
call FreeCollection

;release dataByPsessByName
push pdword [pebx+psize*4]
call FreeCollection

;release garbageCollection
push pdword [pebx+(psize*5)+8]
call FreeCollection

mov eax,dword [pebx+(5*psize)+4]
push peax
call releaseHighestListenSessionsId

;release internal listensession
push pebx
call FreeMemLocation

xor eax,eax
jmp endCreateInternalListenStructure

;------------------------------------------------------------------------------
;This call SavePluginData for every initOptions
;input
;  (R/E)AX (x86) R12 (x64) => psess
;  (R/E)DI => pointer to first BindInitOption
;  (R/E)BX => pointer to internalListenSession or zero
;  (R/E)CX => ammount of BindInitOption structures
;corupts: (R/E)AX, (R/E)DI, (R/E)CX
;------------------------------------------------------------------------------
  loopInitOptions:
    if used is32
      push eax ;save protocol session
    end if

    ;fill in the data from initOptions
    if used is32
      push dword [pedi+(psize*2)+4]	    ;flags
      push dword [pedi+psize*2] 	    ;len
    else
      mov eax,dword [pedi+(psize*2)+4]
      push rax				    ;flags
      mov eax,dword [pedi+(psize*2)]
      push rax				    ;len
    end if

    push pdword [pedi+psize]		    ;data
    push pdword [pedi]			    ;name
    push 0				    ;sess
    push 0				    ;lsess (this one does not exist yet, we pass the internal listensession on (R/E)AX
    if used is64
      push r12				    ;psess
    else
      push peax 			    ;psess
    end if
    push BindToProtocol_SavePluginData_end  ;retv

    test dword [pedi+(psize*2)+4],GDPD_IS_LIST
    jz InitOptionsNotAList

       ;make a call to GetPluginData to get the MultiColumnList
       push 0 ;create space on stack for the return pointer from the list
       push psize ;create space on stack for the len param

      if used is32
	push dword [edi+(psize*2)+4]	      ;flags
      else
	mov eax,dword [rdi+(psize*2)+4]
	push rax			      ;flags
      end if

      push pesp 			      ;&len
      add pdword [pesp],psize*1 	      ;set pointer on free stack space
      push pesp 			      ;data
      add pdword [pesp],psize*3 	      ;set pointer on free stack space
      push pdword [pedi]		      ;name
      push 0				      ;sess
      push 0				      ;lsess
      if used is64
	push r12			      ;psess
      else
	push peax			      ;psess
      end if
      call GetPluginData_asm

      pop peax	     ;clear len param from stack
      pop peax	     ;pointer to the collection list
      test peax,peax
      jz isNotAList

      ;check if the number is indeed a pointer
      push RIGHT_READ or RIGHT_WRITE
      push peax
      call doesVMLocationExists
      test peax,peax
      jz isNotAList

      push peax ;save pointer to list

      ;a list holds a pointer in a pointer, so check if the second number is a valid and readable pointer
      push RIGHT_READ or RIGHT_WRITE
      push pdword [peax]
      call doesVMLocationExists
      test peax,peax

      pop peax ;restore pointer to list

      jnz ListExistsForProtocolSession


      isNotAList:
	add pesp,psize*8 ;clear the pushed values on stack for the SavePluginData_internal_lsess_jump call
	jmp BindToProtocol_No_SavePluginData_Call

    ListExistsForProtocolSession:
      push 1	    ;the itemId of the MultiColumnList in the InternalRowsCollection
      push peax     ;InternalRowsCollection
      call GetDwordItem

      push 0			    ;dont push collection
      push pdword [pedi+psize]	    ;pointer to the first row
      push peax 		    ;push the pointer to the MultiColumnList
      call copyRows
      push peax ;push collection with rows

      test pebx,pebx
      jz IsNotInternalListenSession

	;add the new list to the Garbage collector
	push peax    ;pointer
	push pebx    ;internalListenSession
	push TD_LIST ;type of the pointer
	call addToGarbageFromInternalListenSession
	jmp isInternalListenSession

      IsNotInternalListenSession:

	;add the new list to the Garbage collector
	push peax		      ;pointer
	push TD_LIST		      ;type of the pointer
	push pdword [pesp+psize*4]    ;ProtocolSession
	call addToGarbageFromProtocolSession

      isInternalListenSession:

      ;get data parameter and make a pointer of it(to fix it)
      push psize
      call GetMemLocation

      pop pdword [peax] ;set pointer to collection with rows in new created pointer
      mov pdword [pesp+psize*5],peax ;fill in &data parameter

  InitOptionsNotAList:
    call denter


    push pdword [pebp+psize*2]
    call getInternalProtocolStructure
    ;move internal protocol structure to edi/rdi
    mov pedi,peax

    mov peax,pebx			    ;Internal listen session
    test pebx,pebx
    jz SavePluginDataNotLsess

    jmp SavePluginData_internal_lsess_jump

BindToProtocol_SavePluginData_end:
    test dword [pedi+(psize*2)+4],GDPD_IS_LIST
    jz BindToProtocol_No_SavePluginData_Call

    mov peax,pdword [pesp-psize*3] ;get data parameter of SavePluginData
    ;free the created location
    push peax
    call FreeMemLocation

BindToProtocol_No_SavePluginData_Call:
    if used is32
      pop eax	;restore protocolsession
    end if


    add pedi,(psize*2)+8 ;next BindInitOption structure

     dec pecx
  jnz loopInitOptions
ret

;------------------------------------------------------------------------------
;This function will create a list of pointers to ProtocolSessions from BindStruct
;it will also validate that hte protocols in the BindStruct exists/loaded and it also
;create a ProtocolData strucuture
;input
;  1:BindStruct
;  2:outputList
;  3:outputListIndexed1 :Add for every psess a index new list
;  4:outputListIndexed2 :Add for every psess a index new list
;------------------------------------------------------------------------------
CreateListBindedTohandleListFromBindStruct:
call denter

;create the list for the pointers to the ProtocolSessions
;call CreateCollection
mov pebx,pdword [pebp+psize*3]


mov pedx,pdword [pebp+psize*2] ;Bindstruct
xor ecx,ecx		       ;ammount of extraSize pusht on stack
xor edi,edi		       ;size of the ProtocolData strucuture
if used is32
   xor eax,eax		       ;clear value to keep track of the types of protocols in the listensession
   not eax		       ;EAX = -1
else
   xor r12,r12		       ;clear value to keep track of the types of protocols in the listensession
   not r12		       ;R12 = -1
end if

loopBindStruct:
  if used is32
     push peax
  end if

  ;Check if the protocol is loaded
  push pdword [pedx+psize] ;type
  push pdword [pedx]	   ;ProtocolName
  call getInternalProtocolStructureFromName
  test peax,peax
  jz errCreateListBindedTohandleListFromBindStruct


  mov esi,dword [peax+(7*psize)+0xC]  ;ESI = extraSize
  add esi,SIZEOF_PROTOCOLDATA	      ;size of a protocoldata structure
  add pedi,pesi 		      ;Add extraSize and protocoldata structure to the size param

  if used is32
     xchg esi,dword [esp]	      ;exchange the EAX value pushed before on stack with the size param
     push dword [eax+psize]	      ;push ProtocolSession on stack
     push esi			      ;push value with last use type
     mov esi,dword [eax+psize]	      ;move ProtocolSession to stack
  else
    push rsi			      ;push size parameter on stack
    mov rsi,qword [rax+psize]	      ;RSI = porotocolsession
    push rsi			      ;push ProtocolSession on stack
  end if


  inc ecx			      ;increment ammount of size paramters pusht on stack


  if used is32
    ;check if a PT_LABORER is already in the listensession?
    ;--cmp word [esp],PT_LABORER
    ;--je errCreateListBindedTohandleListFromBindStruct

    ;get Type of the protocol
    mov eax,dword [eax+psize*7+4]

    cmp ax,PT_NO_PROTOCOL
    je errCreateListBindedTohandleListFromBindStruct

    ;test if the protocol is PT_RECEIVER
    test ax,ax
    jnz isNotPT_RECEIVER

    ;check if the PT_RECEIVER protocol already exists in the listensession
    xchg eax,dword [esp]
    test ax,ax
    jz errCreateListBindedTohandleListFromBindStruct

    ;copy previous flags (only neccysery for PT_SUPPORT_PSIGN)
    ;--xor ax,ax
    ;--or dword [esp],eax

    jmp protocolIsOk

  isNotPT_RECEIVER:
    ;test if the protocol is PT_LABORER
    cmp ax,PT_LABORER
    jne protocolIsOk

    cmp word [esp],PT_LABORER
    je PT_LABORER_alreadySet

    xchg eax,dword [esp]
    jmp protocolIsOk

    PT_LABORER_alreadySet:
    ;test if flag PT_SUPPORT_PSIGN is set
    test eax,PT_SUPPORT_PSIGN
    jnz protocolIsOk ;jump if set

    ;switch type with previous type
    xchg eax,dword [esp]


    ;check if flag PT_SUPPORT_PSIGN was set in a previous protocol
    test eax,PT_SUPPORT_PSIGN
    jnz protocolIsOk

    ;check if the PT_RECEIVER protocol already exists in the listensession
    cmp ax,PT_LABORER
    je errCreateListBindedTohandleListFromBindStruct

  protocolIsOk:
  else
    ;check if a PT_LABORER is already in the listensession?
    ;--cmp r12w,PT_LABORER
    ;--je errCreateListBindedTohandleListFromBindStruct

    ;get Type of the protocol
    mov eax,dword [rax+psize*7+4]

    cmp ax,PT_NO_PROTOCOL
    je errCreateListBindedTohandleListFromBindStruct

    ;test if the protocol is PT_RECEIVER
    test ax,ax
    jnz isNotPT_RECEIVER

    ;check if the PT_RECEIVER protocol already exists in the listensession
    test r12w,r12w
    jz errCreateListBindedTohandleListFromBindStruct

    jmp protocolIsOk

  isNotPT_RECEIVER:
    ;test if the protocol is PT_LABORER
    cmp ax,PT_LABORER
    jne protocolIsOk

    ;test if flag PT_SUPPORT_PSIGN is set
    test eax,PT_SUPPORT_PSIGN
    jnz protocolIsOk

    ;check if flag PT_SUPPORT_PSIGN was set in the previous protocol
    test r12d,PT_SUPPORT_PSIGN
    jnz protocolIsOk

    ;check if the PT_RECEIVER protocol already exists in the listensession
    cmp r12w,PT_LABORER
    je errCreateListBindedTohandleListFromBindStruct

  protocolIsOk:
    ;copy value AX and OR the flags on higher word of EAX
    cmp r12w,ax
    cmovnz r12d,eax
    jnz protocolIsOkDone

    ;Only if PT_SUPPORT_PSIGN flag exists in previous and this protocol, keep the flag
    and eax,PT_SUPPORT_PSIGN
    mov ax,r12w
    and r12d,eax

    protocolIsOkDone:
  end if

  ;add ProtocolSession to the list
  push pesi   ;psess
  push pebx   ;list
  call AddDword

  call CreateCollection

  push ADD_POINTER
  push 0
  push peax		     ;item  (new collection)
  push pesi		     ;index (psess)
  push pdword [pebp+psize*4] ;outputListIndexed1
  call AddIndexedItemEx

  call CreateCollection

  push ADD_POINTER
  push 0
  push peax		     ;item  (new collection)
  push pesi		     ;index (psess
  push pdword [pebp+psize*5] ;outputListIndexed2
  call AddIndexedItemEx

  if used is32
     pop peax
  end if

  mov pedx,pdword [pedx+psize+8] ;next BindStruct
  test pedx,pedx
jnz loopBindStruct

if used is32
  ;check if the last protocol was indeed a PT_LABORER, else return
  cmp ax,2
  jne errCreateListBindedTohandleListFromBindStruct
else
  ;check if the last protocol was indeed a PT_LABORER, else return
  cmp r12w,2
  jne errCreateListBindedTohandleListFromBindStruct
end if

xor edx,edx	;Clear value for ProtocolData structure
add pedi,psize ;zero (ending) pointer

;create ProtocolData structure
push pedi
call GetMemLocation
test peax,peax
jz errCreateListBindedTohandleListFromBindStruct

mov pedx,peax
mov pesi,peax ;copy of the pointer

fillInProtocolDataStructure:
  pop pdword [pedx+psize] ;fill in the psess parameter
  pop pedi		  ;pop size param op (R/E)DI
  mov dword [pedx],edi	  ;fill in the size param

  add pedx,pedi 	  ;increment ProtocolData structure by size param
loop fillInProtocolDataStructure

mov peax,pesi

endCreateListBindedTohandleListFromBindStruct:
call dleave
ret psize*4

;-------
;--Err--
;-------
errCreateListBindedTohandleListFromBindStruct:
;push pebx
;call FreeCollection
xor eax,eax
jmp endCreateListBindedTohandleListFromBindStruct

;------------------------------------------------------------------------------
;This function will add one item to a linked list
;------------------------------------------------------------------------------
addToLinkedList:
call denter

mov pedi,pdword [pebp+(psize*2)] ;pointer to list
mov pesi,pdword [pebp+(psize*3)] ;item to add

; Move the first item with this item with do a locked compaired exchange.
againInterLocked:
	mov pecx,pdword [pedi] ;poiner of first item
	mov pdword [pesi],pecx ;set next item on item to add


	mov peax,pecx ;Comparand
	mov pedx,pesi
	lock cmpxchg pdword [pedi], pedx    ;Destination, Exchange,
jnz againInterLocked

call dleave
ret (psize*2)

;------------------------------------------------------------------------------
;This function will create a mem location to a InternalProtocolSession structure
;input:
;  1:psess
;  2:copyPsess
;  3:Pointer to module structure
;output: Pointer to InternalProtocolSession
;------------------------------------------------------------------------------
CreateInternalProtocolStructure:
call denter

push SIZEOF_INTERNALPROTOCOLSTRUCTURE
call GetMemLocation
mov pedi,peax

;fill in psess
mov pecx,pdword [pebp+(psize*2)]
mov pdword [pedi+(psize*1)],pecx

;fill in iPsess    (internal Psess)
mov pecx,pdword [pebp+(psize*3)]
mov pdword [pedi+(psize*2)],pecx

;fill in modStruct (pointer to module structure)
mov pecx,pdword [pebp+(psize*4)]
mov pdword [pedi+(psize*4)],pecx

;fill in  garbageCollection member
call CreateCollection
mov pdword [pedi+(psize*7)+(4*4)+(3*psize)],peax

;fill in status
mov dword [pedi+(psize*7)],PT_STARTING

call CreateCollection
mov pdword [pedi+POS_DATABYNAME_INTERNALPROTOCOL],peax

call CreateCollection
mov pdword [pedi+POS_DATABYINTEGER_INTERNALPROTOCOL],peax

mov peax,pedi

call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will get the module structure from the module handle
;------------------------------------------------------------------------------
getInternalModuleStructure:
pop peax
push psize*1 ;moduleHandle member position
push pdword [modules]  ;linked list with modules
push peax
jmp compairAndGetStructure

;------------------------------------------------------------------------------
;This function will get the internalProtocolStructure from the ProtocolSession
;------------------------------------------------------------------------------
getInternalProtocolStructure:
pop peax ;ret value
push psize*1 ;psess member position
push pdword [protocols]  ;linked list with protocols
push peax ;ret value
;--jmp compairAndGetStructure

;------------------------------------------------------------------------------
;This function will compare a value in the structure of a linked list to find an item
;1: linked list, 2:position, 3:itemToFind
;-----------------------------------------------------------------------------
compairAndGetStructure:
call denter

mov pebx,pdword [pebp+(psize*4)] ;hModule
mov pecx,pdword [pebp+(psize*3)] ;position
mov peax,pdword [pebp+(psize*2)] ;linked list

test peax,peax
jz endGetInternalModuleStructure

isModuleStructure:
    cmp pdword [peax+pecx],pebx
    je endGetInternalModuleStructure

    mov peax,pdword [peax]

    test peax,peax
jnz isModuleStructure


endGetInternalModuleStructure:
call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will get the InternalProtocolStructure from the Protocol name and type
;input
;  1:Protocolname
;  2:Type
;-----------------------------------------------------------------------------
getInternalProtocolStructureFromName:
call denter

mov pesi,pdword [pebp+(psize*2)] ;protocolName
mov pedi,pdword [pebp+(psize*3)] ;Type
inc edi 			 ;increment, so -1 will be zero, easier to detect
test eax,eax			 ;clear return value

mov pedx,pdword [protocols]  ;linked list with protocols

;Test ProtocolName on zero pointer
test pesi,pesi
jz endGetProtocolSessionFromName

;Test linked list on zero pointer
test pedx,pedx
jz endGetProtocolSessionFromName

findProtocolSession:
    mov peax,pdword [pedx+(psize*2)]   ;get the pointer to copyPsess
    mov peax,pdword [peax+psize]       ;pointer to ProtocolName

    ;compaire the Protocolname with the one we try to find
    push peax
    push pesi
    call strcmp
    test eax,eax
    jnz nextProtocolSession

    test edi,edi
    jz foundProtocol

    mov peax,pdword [pedx+(psize*7)+4]	     ;Type of the protocol
    inc eax				     ;increment, just like EDI
    cmp ax,di ;compaire the type (not compaire the higher word, this is for flags, like PT_CONTROLPANEL)
    jne nextProtocolSession

foundProtocol:
    mov peax,pedx
    jmp endGetProtocolSessionFromName


nextProtocolSession:
    ;next InternelProtocolSession
    mov pedx,pdword [pedx]

    test pedx,pedx
jnz findProtocolSession

xor eax,eax

endGetProtocolSessionFromName:
call dleave
ret psize*2

;------------------------------------------------------------------------------
;This function is internal and will check if the pointer psess exists and finds it's internal structure
;It cannot be called from outside, doen't make stack, assumes denter is already called and the first param passed is psess
;------------------------------------------------------------------------------
checkProtocolSession:
pop pedi
mov pebx,pdword [pebp+(psize*2)]

;check if the Virtual pointer exists and has read and write rights
push RIGHT_READ or RIGHT_WRITE
push pebx
call doesVMLocationExists
test eax,eax
jnz continureCheckProtocolSession

jmp pecx

continureCheckProtocolSession:

;check if the psess exists
push pebx
call getInternalProtocolStructure
test peax,peax
jnz returnProtocolSession

mov eax,PSESS_NOT_VALID
call setLastError
jmp pecx

returnProtocolSession:
jmp pedi

;------------------------------------------------------------------------------
;This function is internal and will check if the pointer lsess exists and finds it's internal structure
;It cannot be called from outside, doen't make stack, assumes denter is already called and the second param passed is lsess
;------------------------------------------------------------------------------

checkListenSession:
;get internal ListenSession
push pdword [pebp+psize*3] ;name (lsess)
push [listenSessions]	   ;collectiom
call GetIndexedDwordItem
test peax,peax
jz errcheckListenSession

ret

errcheckListenSession:
mov eax,LSESS_NOT_VALID
add pesp,psize
jmp pecx

;------------------------------------------------------------------------------
;This function is internal and will check if the pointer sess exists and finds it's internal structure
;It cannot be called from outside, doen't make stack, assumes denter is already called and the second param passed is sess
;------------------------------------------------------------------------------

checkClientSession:
;get internal ListenSession
push pdword [pebp+psize*3] ;name (sess)
push [clientSessions]	   ;collectiom
call GetIndexedDwordItem
test peax,peax
jz errcheckClientSession

ret

errcheckClientSession:
mov eax,LSESS_NOT_VALID
add pesp,psize
jmp pecx

;------------------------------------------------------------------------------
;This function will add pointer with type to the carbage collection from a ProtocolSession
;input
;  2:ProtocolSession
;  3:Type
;  3:pointer
;-----------------------------------------------------------------------------
addToGarbageFromProtocolSession:
call denter

;get internal ProtocolSession
mov pecx,endAddToGarbage
call checkProtocolSession

mov pebx,pdword [peax+(psize*7)+(4*4)+(3*psize)]   ;garbageCollection
jmp internalAddToGarbage

;------------------------------------------------------------------------------
;This function will add pointer with type to the carbage collection from a ListenSession or ClientSession
;input
;  1:Type
;  2:ListenSession or ClientSession
;  3:pointer
;-----------------------------------------------------------------------------
addToGarbageFromListenSession:
call denter

;get internal ListenSession
mov pecx,NotListenSession
push isListenSession ;alternative return valu
jmp checkListenSession

NotListenSession:
;get internal ClientSession
mov pecx,endAddToGarbage
call checkClientSession

isListenSession:
mov pebx,pdword [peax+(5*psize)+8]   ;garbageCollection

mov peax,pdword [pebp+psize*2] ;Type
mov pdword [pebp+psize*3],peax ;set type on the correct spot on stack
jmp internalAddToGarbage

;------------------------------------------------------------------------------
;This function will add pointer with type to the carbage collection from a ListenSession
;input
;  1:Type
;  2:InternalListenSession or InternalClientSession
;  3:pointer
;-----------------------------------------------------------------------------
addToGarbageFromInternalListenSession:
call denter

mov peax,pdword [pebp+psize*3] ;internal Listen or ClientSession
mov pebx,pdword [peax+(5*psize)+8]   ;garbageCollection

mov peax,pdword [pebp+psize*2] ;Type
mov pdword [pebp+psize*3],peax ;set type on the correct spot on stack
jmp internalAddToGarbage

;------------------------------------------------------------------------------
;This function will add pointer with type to the carbage collection
;input
;  1:garbageCollection
;  2:Type
;  3:pointer
;-----------------------------------------------------------------------------
addToGarbage:
call denter

mov pebx,pdword [pebp+psize*2] ;garbageCollection

internalAddToGarbage:
;lock garbageCollection
push FULL_LOCK
push pebx
call LockListAcces

;Add type to the collection
push pdword [pebp+psize*3] ;Type
push pebx
call AddDword

;Add pointer to the collection
push pdword [pebp+psize*4] ;pointer
push pebx
call AddDword

push FULL_LOCK
push pebx
call ExternalUnlockListAccesEx

endAddToGarbage:
call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will remove every pointer in the carbageCollection in a proper way  and delete the garbageCollection
;input
;  1:garbageCollection
;-----------------------------------------------------------------------------
disposeGarbage:
call denter

mov pebx,pdword [pebp+psize*2] ;garbageCollection

;lock garbageCollection
push FULL_LOCK
push pebx
call LockListAcces

push pebx
call CountItems
mov ecx,eax
shr ecx,1 ;divide by 2 (every pointer has also an type item before him)
jecxz noGarbageItems

loopGarbageItems:
  mov edx,ecx
  shl edx,1 ;multiply by 2

  ;get pointer
  push pedx
  push pebx
  call GetDwordItem
  mov pesi,peax ;(R/E)SI = pointer to be removed

  dec edx
  ;get type
  push pedx
  push pebx
  call GetDwordItem

  cmp eax, TD_LIST
  jne unknownItem

    push pesi
    call removeInternalRowCollection

unknownItem:
loop loopGarbageItems

noGarbageItems:
push pebx
call FreeDwordCollection

call dleave
ret psize

;------------------------------------------------------------------------------
;This function will remove an internal row collection
;input
;  1:internal row collection
;-----------------------------------------------------------------------------
removeInternalRowCollection:
call denter

mov pebx,pdword [pebp+psize*2] ;internal row collection

;get ammount of items per row
push 2
push pebx
call GetDwordItem
mov edx,eax
;shr edx,1 ;divide by 2 (every pointer has also size param)

;remove pointer to MultiColumnList
push 1
push pebx
call RemoveDwordItem

;remove ammount of items per row
push 1
push pebx
call RemoveDwordItem

;get ammount of items
push pebx
call CountItems
mov ecx,eax ;ammount of rows
jecxz NoInternalRows

loopInternalRowCollection:
  ;get row
  push pecx
  push pebx
  call GetDwordItem
  mov pesi,peax ; (R/E)SI = pointer to row

  if used is64
    mov r12,rdx ;R12 = ammount of items per row
  else
    push edx	;save ammount of items per row
  end if

  test edx,edx
  jz NoItemsInRowToRemove

  call loopInternalRowCollectionItems

  NoItemsInRowToRemove:
  if used is32
    pop edx  ;restore ammount of items per row
  end if

loop loopInternalRowCollection

NoInternalRows:
;free the internal row collection
push pebx
call FreeCollection

call dleave
ret psize

;------------------------------------------------------------------------------
;This function will remove the items of an row
;input
;  (R/E)SI => pointer to row
;  R12 (x64) or EDX (x86) => ammount of items / row
;Corrupts:
;       (R/E)AX, (R/E)DI, (R/E)SI, R12 (x64) or EDX (x86)
;-----------------------------------------------------------------------------
loopInternalRowCollectionItems:
  lodsp ;get size of item
  mov pedi,peax

  lodsp ;get pointer

  test pedi,pedi
  jz isDorQword   ;is size = 0 it is no poiner but a Qword or Dword

  ;free the item
  push peax
  call FreeMemLocation

isDorQword:
  if used is64
    dec r12
  else
    dec edx
  end if
jnz loopInternalRowCollectionItems
ret