
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will call StartListening() from the first binded protocol with a new created Clientsession
;------------------------------------------------------------------------------
callStartListening:
StartProc 1 ;set param sess on stack
call denter
MakeStack

recallStartListening:
;find internal ListenSession
push pdword [pebp+psize*2] ;name (lsess)
push [listenSessions]	   ;collectiom
call GetIndexedDwordItem
mov pesi,peax
mov peax,pdword [peax]	   ;BindedTohandle

;get first psess of binded protocols
push 1
push peax
call GetDwordItem
mov pebx,peax		   ;set psess on (R/E)BX

;get internal protocol session
push peax
call getInternalProtocolStructure
test eax,eax
jz errGetInternalProtocolStructure

;get modstruct
if used is32
  mov pedi,pdword [peax+psize*4]
else
  mov r12,pdword [peax+psize*4]
end if

push pdword [pebp+psize*2]	;lsess
push pesi			;internal lsess
call CreateInternalClientSessionFromInternalListenStructure
mov pesi,peax

push pdword [pebp+psize*2]	;lsess
call copyListenSessionToClientSession
xchg pesi,peax			;xchange internal Clientsession with external clientsession

;Add the internal Listen Structure to the listed, indexed on the ExternalListenSession
push peax	      ;Item   (internal sess)
push pesi	      ;Index  (public sess)
push [clientSessions] ;Collection
call AddIndexedDwordItem ;AddIndexedItem
xor eax,eax ;Clear Item ID

if used is64
  if used isLinux
    push pesi ;save sess
  end if
end if

;Make call to StartListening
argpush 3,pesi			     ;sess
argpush 2,pdword [pebp+psize*2]      ;lsess
argpush 1,pebx			     ;psess
if used is32
  call pdword [pedi+(psize*(2+StartListening))]
else
  call pdword [r12+(psize*(2+StartListening))]
end if
test eax,eax
jz errStartListening

if used is64
  if used isLinux
    pop pesi ;restore sess
  end if
end if

if used isLinux
  lea peax,dword [StartClientSession]
  push pesi
  push peax
else
  push pesi
  push StartClientSession
end if
call createthread


;lea peax,dword [StartClientSession]
;argpush 1,pesi                ;lsess (param)
;call peax                ;baseAddress
;
jmp recallStartListening

errStartListening:

if used is64
  if used isLinux
    pop pesi ;restore sess
  end if
end if

;Remove the internal and external client session that was created for the StartListening function that returned false
push pesi		   ;name (sess)
push [clientSessions]	   ;collection
call RemoveDwordByIndex
push peax
call FreeInternalClientStructure

push pesi
call FreeClientSession

errGetInternalProtocolStructure:
;lock list for write actions whiule we collect the clientsessions binded to this litensession
push [clientSessions]	   ;collection
call LockListWriteAcces

mov pedx,pdword [clientSessions] ;(R/E)DX = pointer to clientsession
mov pesi,pdword [pebp+psize*2]	  ;(R/E)SI = pointer to external ListenSession

push pedx   ;collection
call CountItems
mov ecx,eax ;ECX = ammount of items
xor ebx,ebx ;EBX = 0 (will be used to count the pushed ClientSessions on stack
jecxz waitForClientSessions
shr ecx,1   ;ECX = ECX / 2

collectClientSessions:
  mov eax,ecx ;EAX = current index
  shl eax,1   ;EAX = EAX * 2

  ;Get the InternalClientSession structure
  push peax   ;itemId
  push pedx  ;List clientSessions
  call GetDwordItem
  test peax,peax
  jz nextCollectClientSessions

  ;Is this clientsession binded to our listensession
  cmp pdword [peax+psize],pesi
  jne nextCollectClientSessions

  ;This clientsession is binded to this listensession
  mov eax,ecx ;EAX = current index
  shl eax,1   ;EAX = EAX * 2
  dec eax     ;EAX = itemId of the index in the list

  ;Get the ClientSession structure
  push peax   ;itemId
  push pedx  ;List clientSessions
  call GetDwordItem
  test peax,peax
  jz nextCollectClientSessions

  ;push listensession on stack and inrement ebx
  push peax
  inc ebx

nextCollectClientSessions:
loop collectClientSessions

waitForClientSessions:
  ;unlock the clientsessions list
  push pedx  ;List clientSessions
  call ExternalUnlockListWriteAcces

  ;wait a second before checking if the clientsessions are still active
  push 1000
  call sleep

  ;lock list for write actions whiule we collect the clientsessions binded to this litensession
  push pedx  ;List clientSessions
  call LockListWriteAcces

  mov ecx,ebx ;ECX = ammount
  jecxz endNextCollectClientSessions

  checkClientSessions:
    mov edi,ecx ;current item
    dec edi	;EDI--;
    if used is32
      shl pedi,2  ;(R/E)DI = (R/E)DI*4
    else
      shl pedi,3  ;(R/E)DI = (R/E)DI*8
    end if

    mov peax,pdword [pesp+pedi]  ;get clientsession from stack

    push peax
    push pedx  ;List clientSessions
    call GetIndexedDwordItem
    test peax,peax
    jz zeroClientSession ;Zero the clientsession on stack, since it does not exists annymore

    ;Is this clientsession binded to our listensession
    cmp pdword [peax+psize],pesi
    je waitForClientSessions ;The clientsession still exist, keep waiting
    jmp nextCheckClientSessions

  zeroClientSession:
    mov pdword [pesp+pedi],0 ;zero the clientsession, since it does not exists annymore

  nextCheckClientSessions:
  loop checkClientSessions
endNextCollectClientSessions:

;Ok, all the clientsession binded to this listensession shut down, now we can delete the listensession
if used is32
  shl pebx,2  ;(R/E)BX = (R/E)BX*4
else
  shl pebx,3  ;(R/E)BX = (R/E)BX*8
end if

add pesp,pebx ;clear the pushed clientsession on stack

;unlock the clientsessions list
push pedx  ;List clientSessions
call ExternalUnlockListWriteAcces

;find internal ListenSession
push pesi		   ;name (lsess)
push [listenSessions]	   ;collection
call GetIndexedDwordItem
mov pedx,pdword [peax]	   ;BindedTohandle list

push pedx
call CountItems
mov pecx,peax

;call CloseListenSession of every protocol
callCloseListenSessionLoop:
  ;get psess of binded protocol
  push pecx
  push pedx
  call GetDwordItem
  mov pebx,peax 	     ;set psess on (R/E)BX

  ;get internal protocol session
  push peax
  call getInternalProtocolStructure
  test eax,eax
  jz nextCallCloseListenSessionLoop

  ;get modstruct
  if used is32
    mov pedi,pdword [peax+psize*4]
  else
    mov r12,pdword [peax+psize*4]
  end if

  call denter  ;this will corrupt EAX and save all other registers
  MakeStack

  if used is32
    cmp pdword [pedi+(psize*(2+CloseListenSession))],0
  else
    cmp pdword [r12+(psize*(2+CloseListenSession))],0
  end if
  je notCallCloseListenSession

  argpush 2,pesi		       ;lsess
  argpush 1,pebx		       ;psess
  if used is32
    call pdword [pedi+(psize*(2+CloseListenSession))]
  else
    call pdword [r12+(psize*(2+CloseListenSession))]
  end if

notCallCloseListenSession:
  call dleave  ;retore all registers (except EAX)
nextCallCloseListenSessionLoop:
loop callCloseListenSessionLoop

if used is64
  fixStack 0	;align stack on 0x10  (win x64 calling convention)
  sub pesp,0x10 ;create shadow places for the function call (for windows x64)
end if

;call the registerd ListenSessionIsCreated functions
push [registerdListenSessionIsCreatedFunctions]
call CountItems
mov ecx,eax

jecxz endLoopListenSessionIsCreatedCallbackFunctions2 ;jump when there are no callback functions registerd

loopListenSessionIsCreatedCallbackFunctions2:
  push pecx
  push [registerdListenSessionIsCreatedFunctions]
  call GetDwordItem
  test peax,peax
  jz endLoopListenSessionIsCreatedCallbackFunctions2

  mov pebx,pecx ;save ecx

  argpush 2,LCCF_LSESS_UNLOADED ;LCCF_LSESS_UNLOADED flag
  argpush 1,pesi ;lsess
  call peax ;call ListenSessionIsCreated Callback Function

  mov pecx,pebx ;restore ecx

nextLoopListenSessionIsCreatedCallbackFunctions2:
  loop loopListenSessionIsCreatedCallbackFunctions2
endLoopListenSessionIsCreatedCallbackFunctions2:

;finaly, remove the listensession and quit :)
push pesi		    ;name (lsess)
push [listenSessions]	   ;collection
call RemoveDwordByIndex
push peax
call FreeInternalListenStructure

push pesi
call FreeListenSession

endcallStartListening:
call dleave
EndProc 1
endCreatedThread
ret (FunctionReturnFactor*1)

;------------------------------------------------------------------------------
;The CloseClientSession function shoudl shutdown the connection with the Client
;------------------------------------------------------------------------------
;---------
;C implementation
;---------
if used is64
    CloseListenSession_c:
    StartProc 2

    mov rcx,retCloseListenSession_c
    xchg qword [rsp],rcx
    jmp CloseListenSession_asm

    retCloseListenSession_c:
    sub rsp,2*psize
    EndProc 2
    jmp rcx
else
    CloseListenSession_c:
end if
;---------
;asm implementation
;---------
CloseListenSession_asm:
call denter
MakeStack

;check if Protocolsession and ClientSession are valid
mov pecx,errCloseListenSession
call checkProtocolSession

mov pecx,errCloseListenSession
call checkListenSession

push peax ;save internal listensession

;remove listensession from disk
push peax
call RemoveListenSessionToDisk

pop peax;restore internal listensession

mov peax,pdword [peax] ;Get BindedTohandle from the InternalListenStructure
;Get first psess of the BindedTohandle structure (=>Receiver protocol)
push 1
push peax
call GetDwordItem
mov pebx,peax ;(R/E)BX => Get first psess of the BindedTohandle structure (=>Receiver protocol)

;Get the internal protocol structure of the psess value
push pebx
call getInternalProtocolStructure
test peax,peax
jz errCloseListenSession

mov peax,pdword [peax+psize*4] ;Get modstruct of Internal ProtocolStructure

;call PrepareCloseListenSession
argpush 2,pdword [pebp+psize*3]      ;sess
argpush 1,pebx			     ;psess
if used is64
  call pdword [peax+(psize*(2+PrepareCloseListenSession))]
else
  call pdword [peax+(psize*(2+PrepareCloseListenSession))]
end if

errCloseListenSession:
call dleave
ret psize*2