
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

CLONE_VM	equ 0x00000100
CLONE_FS	equ 0x00000200
CLONE_FILES	equ 0x00000400
CLONE_SIGHAND	equ 0x00000800
CLONE_PTRACE	equ 0x00002000
CLONE_VFORK	equ 0x00004000
CLONE_PARENT	equ 0x00008000
CLONE_THREAD	equ 0x00010000
CLONE_NEWNS	equ 0x00020000	
CLONE_SYSVSEM	equ 0x00040000
CLONE_SETTLS	equ 0x00080000
CLONE_PARENT_SETTID	equ 0x00100000
CLONE_CHILD_CLEARTID	equ 0x00200000
CLONE_DETACHED		equ 0x00400000
CLONE_UNTRACED		equ 0x00800000
CLONE_CHILD_SETTID	equ 0x01000000	
CLONE_STOPPED		equ 0x02000000
SIGCHLD 	equ 17

CLONE_IO	equ 0x80000000

;------------------------------------------------------------------------------
;This function will return the Thread id of the currrent thread
;return: Thread Id
;-----------------------------------------------------------------------------
if used getCurThreadid
   getCurThreadid:
   call denter
   MakeStack

   linuxCall 186,224  ;sys_gettid

   call dleave
   ret
end if

;------------------------------------------------------------------------------
;This function will set the thread in WAIT position for x miliseconds
;param:
;  mili: the time in miliseconds to be in WAIT pos
;-----------------------------------------------------------------------------

if used sleep
   sleep:
   call denter
   MakeStack

   ;devide by 1000 (1 second
   mov peax,pdword [pebp+(psize*2)]
   mov ecx,1000
   xor edx,edx
   div pecx

   ;fill in the struct
   push pedx  ;nano seconds
   push peax  ;seconds
   mov pebx,pesp

   argpushsys 2,0
   argpushsys 1,pebx
   linuxCall 35,162 ;sys_nanosleep

   add pesp,psize*2

   call dleave
   ret psize
end if

;------------------------------------------------------------------------------
;This function will create a new thread with one parameter
;param:
;  base:  the base address to start the thread
;  param: the param r zero in failure
;-----------------------------------------------------------------------------
if used createthread
createthread:
call denter

push 0
mov pebx,pesp

argpush 4,pdword [rbp+psize*3]
argpush 3,pdword [rbp+psize*2]
argpush 2,0
argpush 1,pebx
call [pthread_create]

pop peax
call dleave
ret psize*2
end if

;Create stack
;argpushsys 6,0 ;offset
;argpushsys 5,-1 ;fd
;argpushsys 4,MAP_ANONYMOUS or MAP_PRIVATE or MAP_GROWSDOWN or MAP_STACK ;flags
;argpushsys 3,PROT_READ or PROT_WRITE ;IPPROTO_TCP or IPPROTO_UDP
;argpushsys 2,1024*5 ;lenngth
;argpushsys 1,0 ;addr
;linuxCall 9,192  ;sys_mmap2
;mov pecx,peax   ;(R/E)CX = Stack
;
;add pecx,(1024*5)-psize
;
;;set return address on stack
;;mov pdword [pecx],endThread
;
;
;;create pt_regs structure
;if used is64
;   push 21*psize
;else
;   push 17*psize
;end if
;call GetMemLocation
;mov pedi,peax   ;(R/E)DI = pt_regs
;
;;set start address
;mov peax,pdword [pebp+psize*2]
;if used is32
;   mov dword [edi+psize*10],eax ;ip = start address(of 12??)
;else
;   mov qword [rdi+psize*16],rax ;ip = start address
;end if
;
;;set param on register (x64) or stack (x86)
;if used is64
;  mov rax,qword [rbp+psize*3]
;  mov qword [rdi+psize*14],rax ;RDI = param
;else
;  mov eax,dword [ebp+psize*3]
;  sub ecx,psize        ;esp-4
;  mov dword [ecx],eax  ;[esp] = param
;end if
;
;;Tid
;push 0
;mov pesi,pesp
;
;push pedi
;
;
;int3
;;argpushsys 5,pedi ;registers
;;argpushsys 4,pesi ;tID (Thread Id)
;;argpushsys 3,0
;;argpushsys 2,pecx ;stack
;;argpushsys 1,CLONE_FILES or CLONE_FS or  CLONE_IO or CLONE_VM or SIGCHLD ;or CLONE_CHILD_SETTID or CLONE_NEWNS
;;linuxCall 56,120 ;sys_clone
;
;;-argpushsys 5,pedi ;registers
;;-argpushsys 4,pesi ;tID (Thread Id)
;;-argpushsys 3,0
;argpushsys 3,CLONE_FILES or CLONE_FS or  CLONE_IO or CLONE_VM or SIGCHLD ;or CLONE_CHILD_SETTID or CLONE_NEWNS
;argpushsys 2,pecx ;stack
;argpushsys 1,pdword [pebp+psize*2]
;linuxCall 56,120 ;sys_clone
;
;pop pedi
;
;push pedi
;call FreeMemLocation ;free pt_regs
;
;pop peax ;Thread Id
;
;call dleave
;ret psize*2
;
;end if
;
;
;
;;------------------------------------------------------------------------------
;;This function will clear the stack and end the thread
;;-----------------------------------------------------------------------------
;endThread:
;;delete stack
;sub pesp,psize
;
;;remove stack
;argpushsys 2,pdword [pesp]
;argpushsys 1,pesp
;linuxCall 11,91  ;munmap
;
;argpushsys 1,0
;linuxCall 60,1  ;exit
;
;;----

macro endThread
{ common
argpushsys 1,0
linuxCall 60,1	;exit
}

macro endCreatedThread
{common
push 0
call [pthread_exit]
}