testCookieStr db 'hello;world !@#$%&*',0
testCookiename db 'hi',0
testCookiename2 db 'hi2',0
testCookieDomain db '127.0.0.1',0
testCookiePath db '/',0

realm db 'hello world',0
domain db '127.0.0.1',0
nonce db 'mynonce',0
opaque db 'myOpaque',0
algorithm db 'SHA-0',0


;------------------------------------------------------------------------------
;This function will initialize the ClientSession (if TCP) and handle the connection (if HTTP)
;------------------------------------------------------------------------------
HandleConnection:
StartProc 2 ;Set arguments on stack
call denter

xor eax,eax ;return value

mov pedx,pdword [pebp+psize*2]	;psess
mov pecx,pdword [pebp+psize*3]	;sess

cmp [psess_TCP],pedx
je handleTCP

cmp [psess_HTTP],pedx
jne endHandleConnection
;
;Handle HTTP
;

push 0

push pesp ;*error
push RPF_USE_TIME_LIMIT or RPF_USE_HEADER_SIZE_LIMIT ;flags
push 1000*20	  ;maxTimeToReceive
push 5*1024*1024  ;maxHeaderSizeLimit (5MB)
push pdword [pebp+psize*3]
push pdword [pebp+psize*2]
call [RecvAndParseHTTP]

pop pedi ;error code

mov pebx,peax
test pebx,pebx
jz dontFreeHttpSession

;push testCookiename2      ;'hi2'
;push pdword [pebx+psize*3] ;collection
;call [GetCollectionItem]

;push 0
;push peax
;call message

;mov pedi,pdword [pebx] ;defaultVariables
mov pedi,pdword [pebx+psize*5] ;URLbuffer

;-push 0
;-push pedi
;-call message

push 0
push pedi
call [ConvertEscapedCharactersToBytes]

push pedi
call [DeleteDoubleSlashesInUrl]

push pedi
call [DecodeURL]
test eax,eax
jz errorDecodingURL

push 0
push pedi
call message

errorDecodingURL:
push pebx
call [FreeHTTPSession]

xor edi,edi

dontFreeHttpSession:
test edi,edi
jz noErrorInRecvFunction

  add edi,0x30
  push pedi
  mov pedi,pesp

  push 1

 ; push pesp                                           ;&len
  ;push pedi                                           ;buff
  ;push DEFAULT_SENDTIMEOUT                             ;timeout
  ;push 0                                              ;flags
  ;push pecx                                           ;sess
  ;push pedx                                           ;psess
  ;call [SendData]

  add pesp,psize*2

noErrorInRecvFunction:

if used is32
  sub esp,0x8 ;make space for qword
  mov dword [esp],100
  mov dword [esp+4],0
  mov eax,esp  ;content-length

  sub esp,0x8 ;make space for qword
  mov dword [esp],0x59376174-100
  mov dword [esp+4],0x5871
  mov esi,esp  ;content_range_offset

  sub esp,0x8 ;make space for qword
  mov dword [esp],0x59376174
  mov dword [esp+4],0x5871
  mov edi,esp  ;content_range_total_length
end if

sub pesp,16*psize
mov pdword [pesp+psize],200
mov pdword [pesp+psize*2],2 ;set content_type text/html
mov dword [pesp], 0x40 or 0x100 ;flags     4 or     0x10 or 0x20 or

mov pdword [pesp+psize*10],1 ;flags
mov pdword [pesp+psize*11],realm ;realm
mov pdword [pesp+psize*12],domain ;domain
mov pdword [pesp+psize*13],nonce ;nonce
mov pdword [pesp+psize*14],opaque ;opaque
mov pdword [pesp+psize*15],algorithm ;algorithm

if used is32
  mov dword [esp+4*psize],eax
  mov dword [esp+5*psize],esi
  mov dword [esp+6*psize],edi
else

  mov qword [rsp+4*psize],100
  mov rax,0x587159376174
  mov qword [rsp+6*psize],rax ;content_range_total_length
  sub rax,100
  mov qword [rsp+5*psize],rax ;content_range_offset
  mov pdword [rsp+psize*8],-1
end if

;create cookie_field structure
push 7*psize
call GetMemLocation
mov pedi,peax

mov pdword [peax+psize*2],testCookiename ;set name
mov pdword [peax+psize*3],testCookieStr ;set value
;mov pdword [peax+psize*4],testCookieDomain ;set domain
;mov pdword [peax+psize*5],testCookiePath ;set path
if used is32
  mov dword [eax+psize*7],50*365*24*60*60 ;expire is about 2020
  mov dword [eax+psize*8],0
  lea ecx,dword [eax+psize*7]
  mov pdword [peax+psize*6],ecx
else
  mov pdword [peax+psize*6],50*365*24*60*60 ;set expires
end if

mov pdword [peax+psize],0x10 ;CF_SECURE (0x1) or CF_HTTP_ONLY (0x2) or CF_SEND_EXPIRES_DATE

mov [pesp+psize*9],peax ;set cookie_field

;create cookie_field structure
push 7*psize
call GetMemLocation
mov pdword [pedi],peax

mov pdword [peax+psize*2],testCookiename2 ;set name
mov pdword [peax+psize*3],testCookieStr ;set value
mov pdword [peax+psize],0 ;CF_SECURE

push pesp
push pdword [pebp+psize*3]
push pdword [pebp+psize*2]
call [SendHTTPHeader]

add pesp,16*psize
if used is32
  sub esp,0x8
end if

jmp skipEchoReceiveLoop

push dfsdf
push pdword [pebx+psize*2]
call [GetCollectionItem]
mov pedi,peax

push pedi
call strlen

push peax

push pesp					    ;&len
push pedi					    ;buff
push DEFAULT_SENDTIMEOUT			    ;timeout
push 0						    ;flags
push pecx					    ;sess
push pedx					    ;psess
call [SendData]

add pesp,psize

push pebx
call [FreeHTTPSession]

push 10
call GetMemLocation
mov pebx,peax
jmp endEchoReceiveLoop

push 10

push pesp					    ;&len
push pebx					    ;buff
push 1000					    ;timeout
push RSF_RETURN_ON_FIRST_SUCCESSFUL_ATTEMPT or RSF_PEEK_DATA	;flags
push pecx					    ;sess
push pedx					    ;psess
call [RecvData]
test eax,eax
jnz endEchoReceiveLoop

add pesp,psize

echoReceiveLoop:
  push 10

  push pesp					      ;&len
  push pebx					      ;buff
  push 100					      ;timeout
  push RSF_RETURN_ON_FIRST_SUCCESSFUL_ATTEMPT	      ;flags
  push pecx					      ;sess
  push pedx					      ;psess
  call [RecvData]
  test eax,eax
  jnz endEchoReceiveLoop

  push pesp					      ;&len
  push pebx					      ;buff
  push DEFAULT_SENDTIMEOUT			      ;timeout
  push 0					      ;flags
  push pecx					      ;sess
  push pedx					      ;psess
  call [SendData]
  test eax,eax
  jnz endEchoReceiveLoop

  add pesp,psize
jmp echoReceiveLoop

endEchoReceiveLoop:

push pebx
call FreeMemLocation

skipEchoReceiveLoop:
push 0

push pesp					    ;&len
push 0						    ;buf
push CSI_CLIENT_ADDRESS or CSI_ASCII_STRING	     ;type
push pecx					    ;sess
push pedx					    ;psess
call [GetClientSessionInfo]

call GetMemLocation
mov pedi,peax

sub pesp,psize

push pesp					    ;&len
push pedi					    ;buf
push CSI_CLIENT_ADDRESS or CSI_ASCII_STRING	    ;type
push pecx					    ;sess
push pedx					    ;psess
call [GetClientSessionInfo]

add pesp,psize

push pedi
call strlen

push peax

push pesp					    ;&len
push pedi					    ;buff
push DEFAULT_SENDTIMEOUT			    ;timeout
push 0						    ;flags
push pecx					    ;sess
push pedx					    ;psess
call [SendData]

add pesp,psize

push pedi
call FreeMemLocation
jmp endHandleConnection

handleTCP:
;
;Handle TCP
;
;find the data member of this protocol
push pdword [pecx+8]	   ;ProtocolData structure
push pedx		   ;psess
call [FindProtocolDataStruct]
mov pesi,pdword [peax+psize*2] ;SOCKET

;This event takes care of functions recv returning if there is no data (else it would be placed in a WAIT state)
push pesi		       ;SOCKET
call CreateSocketEvent
mov pebx,peax


;call the next HandleConnection function from the other protocols
push pecx	;sess
push pedx	;psess
call [CallNextHandleConnection]
mov pedi,peax			;return value of the other HandleConnection



;------------------------------
;Clean up all the open handles
;------------------------------
push pebx
call CloseSocketEvent

push pesi
call SaflyCloseTCPSocket

mov peax,pedi ;set return value back
endHandleConnection:
call dleave
EndProc 2
ret (FunctionReturnFactor*2)

;------------------------------------------------------------------------------
;This function will close the TCP connection  (or the listen socket)
;------------------------------------------------------------------------------
CloseClientSession_TCP:
StartProc 2 ;Set arguments on stack
call denter

mov pecx,pdword [pebp+psize*3]	;sess

;find the data member of this protocol
push pdword [pecx+8]	   ;ProtocolData structure
push pdword [pebp+psize*2] ;psess
call [FindProtocolDataStruct]

push pdword [peax+psize*2]
call SaflyCloseTCPSocket

call dleave
ret (FunctionReturnFactor*2)

;------------------------------------------------------------------------------
;This function will receive data from the TCP connection
;------------------------------------------------------------------------------
RecvData_TCP:
StartProc 6 ;Set arguments on stack
call denter

xor eax,eax ;return value

;check if the psess value is TCP
mov pecx,pdword [pebp+(psize*2)] ;psess
cmp [psess_TCP],pecx
jne endRecvData_TCP

;find the data member of this protocol
mov pecx,pdword [pebp+psize*3]	;lsess

push pdword [pecx+8]	   ;ProtocolData structure
push pdword [pebp+psize*2] ;psess
call [FindProtocolDataStruct]
mov pebx,pdword [peax+psize*2] ;get the socket from the data member

push pdword [pebp+psize*7]  ;*len
push pdword [pebp+psize*6]  ;buf
push pdword [pebp+psize*5]  ;timeout
push pdword [pebp+psize*4]  ;flags
push pebx		    ;SOCKET
call RecvSocketData


endRecvData_TCP:
call dleave
EndProc 4
ret (FunctionReturnFactor*6)

;------------------------------------------------------------------------------
;This function will send data to the client the TCP connection
;------------------------------------------------------------------------------
SendData_TCP:
StartProc 6 ;Set arguments on stack
call denter

xor eax,eax ;return value

;check if the psess value is TCP
mov pecx,pdword [pebp+(psize*2)] ;psess
cmp [psess_TCP],pecx
jne endSendData_TCP

;find the data member of this protocol
mov pecx,pdword [pebp+psize*3]	;lsess

push pdword [pecx+8]	   ;ProtocolData structure
push pdword [pebp+psize*2] ;psess
call [FindProtocolDataStruct]
mov pebx,pdword [peax+psize*2] ;get the socket from the data member

push pdword [pebp+psize*7]  ;*len
push pdword [pebp+psize*6]  ;buf
push pdword [pebp+psize*5]  ;timeout
push pdword [pebp+psize*4]  ;flags
push pebx		    ;SOCKET
call SendSocketData


endSendData_TCP:
call dleave
EndProc 4
ret (FunctionReturnFactor*6)

;------------------------------------------------------------------------------
;This function will send inofrmation about the clientsession
;------------------------------------------------------------------------------
GetClientSessionInfo_TCP:
StartProc 5 ;Set arguments on stack
call denter

;find the data member of this protocol
mov pecx,pdword [pebp+psize*3]	;lsess
mov pedx,pdword [pebp+psize*4]	;flags
mov pedi,pdword [pebp+psize*5]	;buff

push pdword [pecx+8]	   ;ProtocolData structure
push pdword [pebp+psize*2] ;psess
call [FindProtocolDataStruct]
lea pesi,pdword [peax+psize*3]	;(R/E)SI => pointer to {sizeof(sockaddr_in), sockaddr_in}

test dx,dx  ;CSI_CLIENT_ADDRESS
jz getClientAddress

dec dx	    ;CSI_CLIENT_PORT
jz getClientPort

dec dx	    ;CSI_LOCAL_ADDRESS
jz getLocalAddress

dec dx	    ;CSI_LOCAL_PORT
jz getLocalPort

jmp endGetClientSessionInfo

;-----------------
;CSI_CLIENT_ADDRESS
;-----------------
getClientAddress:
push pesi    ;pointer to {sizeof(sockaddr_in), sockaddr_in}
call GetSinAddr
;(R/E)AX => pointer to sin6_addr or sin_addr
;(R/E)CX => size of sin6_addr or sin_addr
test edx,CSI_RAW_DATA
jnz copyRawData

push pedx		   ;flags
push pdword [pebp+psize*6] ;&len
push pedi		   ;buffer
push pesi		   ;pointer to {sizeof(sockaddr_in), sockaddr_in}
call ConvertAddress
jmp endGetClientSessionInfo

;-----------------
;CSI_CLIENT_PORT
;-----------------
getClientPort:
add pesi,psize ;seem to sockaddr_in structure
push pesi
call GetPort
mov ecx,2 ;port is 2 bytes
;(R/E)AX => port
;(R/E)CX => 2 bytes (size of port)
test edx,CSI_RAW_DATA
jnz copyRawDataNoPointer

mov pecx,pdword [pebp+psize*6]
cmp dword [pecx],4
jae sufficientBufferGetClientPort

mov dword [pecx],4
xor eax,eax
jmp endGetClientSessionInfo

sufficientBufferGetClientPort:
mov pecx,IntToStr
mov pesi,IntToStrW
test pedx,CSI_ASCII_STRING
cmovz pecx,pesi

;convert port to string
push 10     ;divide by 10
push pedi   ;output buffer
push peax   ;port
call pecx

;return 1;
xor eax,eax
inc eax
jmp endGetClientSessionInfo

;-----------------
;CSI_LOCAL_ADDRESS
;-----------------
getLocalAddress:
add pesi,0x20+psize ;get sockadd_in from local address
jmp getClientAddress

;-----------------
;CSI_LOCAL_PORT
;-----------------
getLocalPort:
add pesi,0x20+psize ;get sockadd_in from local address
jmp getClientPort

copyRawDataNoPointer:
push peax
mov peax,pesp

copyRawData:
xchg pesi,peax ;(R/E)SI = source, (R/E)DI = destination

rep stosb ;copy the raw data

xor eax,eax
inc eax

endGetClientSessionInfo:
call dleave
ret (FunctionReturnFactor*5)