
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

format PE64 GUI 4.0 DLL
entry main

section '.text' code data readable writeable executable
dd 0x00000000 ;version (lowerword = new version, higherword=new functions but still supports older versions)
dq __asm_exchange_tables
dq RecvAndParseHTTP
dq FreeHttpSession
dq SendHTTPHeader
dq ConvertEscapedCharactersToBytes
dq GetIndexedStringItemWithHash
dq EscapeAndSendValue_Export
dq EscapeHtmlAndSendValue_Export
dq DeleteDoubleSlashesInUrl
dq DecodeURL
dq SendFile
dq getMimeTypeFromExtension

include 'windows/Use64.inc'
include 'include/flags.inc'
include 'windows/register.inc'       ;HTTP protocol
include 'windows/callconvention.inc' ;HTTP protocol
include 'windows/timedate.inc'       ;HTTP protocol
include 'windows/fileFunctions.inc'  ;HTTP protocol
include 'windows/memfunctions.inc'
include 'include_http_protocol/tvs_server_http_protocol_base.asm'
include 'windows/threadfunctions.inc'
include 'windows/user.inc'
include 'include_http_protocol/plugin_export_list.inc'
include 'include_http_protocol/readable_writeable_data.inc'

data export
  export 'tvs_server_http_protocol_x64.DLL',\
         __asm_exchange_tables_c,'__asm_exchange_tables_http',\
         RecvAndParseHTTP_c, 'RecvAndParseHTTP',\
         FreeHttpSession_c, 'FreeHTTPSession',\
         SendHTTPHeader_c, 'SendHTTPHeader',\
         ConvertEscapedCharactersToBytes_c, 'ConvertEscapedCharactersToBytes',\
         GetIndexedStringItemWithHash_c,'GetCollectionItem',\
         EscapeAndSendValue_c,'EscapeAndSendValue',\
         EscapeHtmlAndSendValue_c,'EscapeHtmlAndSendValue',\
         DeleteDoubleSlashesInUrl_c,'DeleteDoubleSlashesInUrl',\
         DecodeURL_c,'DecodeURL',\
         SendFile_c,'SendFile';,\
         ;getMimeTypeFromExtension,'__GetMimeTypeFromExtension'
end data

data import
library kernel32,'KERNEL32.DLL',\
        advapi32,'ADVAPI32.DLL',\
        user32,'USER32.DLL'

include 'windows\adapted_KERNEL32.INC'
include 'API\ADVAPI32.INC'
include 'API\USER32.INC'
end data

data resource
  directory RT_VERSION,versions

  resource versions,\
           1,LANG_NEUTRAL,version

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
              'FileDescription',"HTTP protocol parser x64",\
              'LegalCopyright',<'Tycho Veltmeijer Copyright ',0A9h,' 2014.'>,\
              'FileVersion',"3.00.00.01",\
              'ProductVersion',"3.00.00"
end data

section '.reloc' fixups data readable discardable