
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

RIGHT_READ equ 0x1
RIGHT_WRITE equ 0x2
RIGHT_EXECUTE equ 0x4

DONT_COPY_OLD_DATA equ 0x1

if used GetPageSize
pageSize dd 0
end if

if used initGetSmallestPortionPageAllocation
smallestPortionOfPageSize dd 0

;------------------------------------------------------------------------------
;Derterminate the smallest size that the VirtualAlloc function can allocate
;------------------------------------------------------------------------------
initGetSmallestPortionPageAllocation:
cmp [smallestPortionOfPageSize],0
jne endInitGetSmallestPortionPageAllocation

push pesi

push 10
call GetMemLocationPage
mov pesi,peax

push 0
push pesp
push 1 ;read
push pesi
call doesVMLocationExistsEx

push pesi
call FreeMemLocation

if used is32
  pop [smallestPortionOfPageSize] ;smallest possible size memory allocation
else
  pop peax
  mov [smallestPortionOfPageSize],eax
end if

pop pesi

endInitGetSmallestPortionPageAllocation:
ret

;------------------------------------------------------------------------------
;Receive the smallest size that the VirtualAlloc function can allocate
;------------------------------------------------------------------------------
GetSmallestPortionPageAllocation:
mov eax,dword [smallestPortionOfPageSize]
ret
end if

;------------------------------------------------------------------------------
;Get the size of 1 page
;------------------------------------------------------------------------------
if used GetPageSize
GetPageSize:
mov eax,[pageSize]
test eax,eax
jnz endGetPageSize

call denter
;Create SYSTEM_INFO
;typedef struct _SYSTEM_INFO {
;  union {
;    DWORD  dwOemId;
;    struct {
;      WORD wProcessorArchitecture;
;      WORD wReserved;
;    };
;  };
;  DWORD     dwPageSize;
;  LPVOID    lpMinimumApplicationAddress;
;  LPVOID    lpMaximumApplicationAddress;
;  DWORD_PTR dwActiveProcessorMask;
;  DWORD     dwNumberOfProcessors;
;  DWORD     dwProcessorType;
;  DWORD     dwAllocationGranularity;
;  WORD      wProcessorLevel;
;  WORD      wProcessorRevision;
;} SYSTEM_INFO;
sub pesp,4*3 + 2*psize + psize + 4*4
mov pebx,pesp
MakeStack

argpush 1,pebx
call [GetSystemInfo]

mov eax,dword [pebx+8] ;dwPageSize
mov [pageSize],eax

call dleave
endGetPageSize:
ret
end if

;------------------------------------------------------------------------------
;This function check pointer 1 with rights 2 and jumps to 3 if invalid
;input:
;   1:Pointer to check
;   2:rights to check on
;   3:Pionter to jump to if pointer does not exists
;output:
;    INVALID_POINTER (4) or 1 (VALID_POINTER)
;------------------------------------------------------------------------------
saveCheckPointer:
;
;not supported on linux
;
if used isLinux
  ret  psize*3
end if
call denter

mov pedx,invalidResultSaveCheckPointer
mov pecx,pdword [pebp+psize*3]
mov peax,pdword [pebp+psize*2]
call checkPointer

call dleave
ret psize*3

invalidResultSaveCheckPointer:
call dleave

add pesp,psize*4
jmp pdword [pesp-(psize*1)]


;------------------------------------------------------------------------------
;This function check pointer on eax/rax with rights ecx\rcx and jumps to edx\rdx if invalid
;input:
;   (R/E)AX: Pointer to check
;   (R/E)CX: Rights the memory should have
;   (R/E)DX: Pointer to jump to if the pointer of (R/E)AX does not exists
;corupted:
;       (R/E)DI
;output:
;    INVALID_POINTER (4) or 1 (VALID_POINTER)
;------------------------------------------------------------------------------
checkPointer:
pop pedi

;check pointer to ControlPanelOptions structure
push pecx ;RIGHT_READ
push peax ;pdword [pebp+(psize*3)]
call doesVMLocationExists
test eax,eax
jnz continueCheckPointer

mov eax,4;INVALID_POINTER
jmp pedx

continueCheckPointer:
jmp pedi


;------------------------------------------------------------------------------
;This function will make a new reallocable memory location with the required size 1:mem location
;------------------------------------------------------------------------------
if used GetMemLocationReAlloc
GetMemLocationReAlloc:
end if

;------------------------------------------------------------------------------
;This function will make a new memory location with the required size 1:mem location
;------------------------------------------------------------------------------
if used GetMemLocation | used GetMemLocationPage | used GetMemLocationReAlloc
  GetMemLocationPage:
  GetMemLocation:
  call denter
  MakeStack

  mov peax,pdword [pebp+(psize*2)]

  argpush 4,0x40
  argpush 3,0x1000
  argpush 2,peax
  argpush 1,0
  call [VirtualAlloc]

  call dleave
  ret (psize*1)
end if

;------------------------------------------------------------------------------
;This function will free a memory location 1:mem location
;------------------------------------------------------------------------------
if used FreeMemLocation | used FreeMemLocationReAlloc | used FreeMemLocationPage | used FreeCallerMemLocation | used FuncUnsafeFreeMemLocation
  FreeCallerMemLocation:
  FreeMemLocationReAlloc:
  FreeMemLocationPage:
  FreeMemLocation:
  ;call denter
  ;MakeStack

  ;mov pecx,pdword [pebp+(psize*2)]
  ;jpcxz NothingToFree

  ;push 0

  ;push pesp
  ;push 0
  ;push pecx
  ;call doesVMLocationExistsEx

  ;pop peax
  ;test peax,peax
  ;jz NothingToFree
  ;jmp UnsafeFreeMemLocation

FuncUnsafeFreeMemLocation:
  call denter
  MakeStack

  mov pecx,pdword [pebp+(psize*2)]
  jpcxz NothingToFree

UnsafeFreeMemLocation:

  argpush 3,0x8000
  argpush 2,0
  argpush 1,pecx
  call [VirtualFree]

  NothingToFree:
  call dleave
  ret (psize*1)
end if


;------------------------------------------------------------------------------
;This function will resize the memory if necessary, but will not restore the current data 1:original mem location 2:required space
;------------------------------------------------------------------------------
if used ReSizeMem
ReSizeMem:
	xor eax,eax
	inc eax
	xchg peax,pdword [pesp+psize*2] ;xchange required space with one (flag DONT_COPY_OLD_DATA)
	xchg peax,pdword [pesp+psize]	;xchange original mem location with required space
	xchg peax,pdword [pesp] 	;xchange return address  with original mem location
	push peax			;push return address
	jmp ReAllocMemEx
end if

;------------------------------------------------------------------------------
;This function will resize the memory if necessary 1:original mem location 2:required space
;------------------------------------------------------------------------------
if used ReAllocMem | used ReAllocMemPage
ReAllocMemPage:
ReAllocMem:
	xor eax,eax
	xchg peax,pdword [pesp+psize*2] ;xchange required space with zero (flag COPY_DATA)
	xchg peax,pdword [pesp+psize]	;xchange original mem location with required space
	xchg peax,pdword [pesp] 	;xchange return address  with original mem location
	push peax			;push return address
	jmp ReAllocMemEx
end if

;------------------------------------------------------------------------------
;This function will resize the memory without checking if necessary 1:original mem location 2:required space
;------------------------------------------------------------------------------
if used ReAllocMemNoCheck
ReAllocMemNoCheck:
	mov eax,2
	xchg peax,pdword [pesp+psize*2] ;xchange required space with zero (flag COPY_DATA ;| DONT_CHECK_ORIGINAL_SIZE)
	xchg peax,pdword [pesp+psize]	;xchange original mem location with required space
	xchg peax,pdword [pesp] 	;xchange return address  with original mem location
	push peax			;push return address
	jmp ReAllocMemEx
end if

;------------------------------------------------------------------------------
;This function will resize the memory if necessary 1:original mem location 2:required space 3:flags
;Flags:
;COPY_DATA 0x0
;DONT_COPY_OLD_DATA 0x1
;DONT_CHECK_ORIGINAL_SIZE 0x2  => danarous (wrong size it will copy), this flag is disabled
;------------------------------------------------------------------------------
if used ReAllocMemEx
	ReAllocMemEx:
	call denter

	;load original adress of (r/e)si and the required size on (r/e)dx
	mov pesi,pdword [pebp+psize*2]
	mov pedx,pdword [pebp+psize*3]

	;--DISABLEDtest pdword [pebp+psize*4],0x2 ;DONT_CHECK_ORIGINAL_SIZE
	;--DISABLEDjnz skipSizeCheck

	;Get the size of the current memory
	push 0

	push pesp
	push RIGHT_READ
	push pesi
	call doesVMLocationExistsEx

	pop pecx ;the original size

	;check if there is already sufficient space, return
	cmp pecx,pedx
	cmovae peax,pesi
	jae endReAllocMem

      skipSizeCheck:
	;get a new (bigger) memory location
	push pedx
	call GetMemLocation
	mov pedi,peax
	mov pebx,peax

	test dword [pebp+psize*4],1
     jnz dontCopyOldData

	;copy the old data to the new pointer
	rep movsb

	dontCopyOldData:
	;release the original memory
	push pdword [pebp+psize*2]
	call FreeMemLocationReAlloc

	mov peax,pebx

	endReAllocMem:
	call dleave
	ret psize*3
end if

;------------------------------------------------------------------------------
;This function will resize the destination to the size of the source memory and copy the data
;1:destination mem location
;2:source mem location
;------------------------------------------------------------------------------
if used cpyMemAndRealoc | used cpyMemAndRealocPage
	cpyMemAndRealocPage:
	cpyMemAndRealoc:
	call denter

	;load original adress of (r/e)si and the required size on (r/e)dx
	mov pesi,pdword [pebp+psize*3] ;source
	mov pedi,pdword [pebp+psize*2] ;destination
	mov pebx,pedi		       ;EBX = destination

	;Get the size of the source
	push 0

	push pesp
	push RIGHT_READ
	push pesi
	call doesVMLocationExistsEx

	pop pecx ;the original size

	;Get the size of destination
	push 0

	push pesp
	push RIGHT_READ
	push pedi
	call doesVMLocationExistsEx

	pop pedx ;the original size

	;check if there is already sufficient space, return
	cmp pecx,pedx
	cmovae peax,pesi
	jae copyTheSourceToDestination

	;resize the destination
	push pecx
	push pedi
	call ReSizeMem
	mov pebx,peax	;EBX = destination
	mov pedi,peax	;EDI = destination

	copyTheSourceToDestination:
	;copy the old data to the new pointer
	rep movsb

	mov peax,pebx

	endcpyMemAndRealoc:
	call dleave
	ret psize*2
end if

;------------------------------------------------------------------------------
;This function will check if the VM location exists and check the rights:
;int doesVMLocationExists(mem:void*, requiredRights:int)
;requiredRights can be:
;---RIGHT_READ 0x1
;---RIGHT_WRITE 0x2
;---RIGHT_EXECUTE 0x4
;------------------------------------------------------------------------------
if used doesVMLocationExists
   doesVMLocationExists:
   xor eax,eax
   xchg peax,pdword [pesp+psize*2] ;xchange requiredRights with zero (return value for size)
   xchg peax,pdword [pesp+psize]   ;xchange mem with requiredRights
   xchg peax,pdword [pesp]	   ;xchange return address with mem
   push peax			   ;push return address
   jmp doesVMLocationExistsEx
end if

;------------------------------------------------------------------------------
;This function will check if the VM location exists and check the rights:
;int doesVMLocationExistsEx(mem:void*, requiredRights:int, *size:int)
;requiredRights can be:
;---RIGHT_READ 0x1
;---RIGHT_WRITE 0x2
;---RIGHT_EXECUTE 0x4
;------------------------------------------------------------------------------
if used doesVMLocationExistsEx
   doesVMLocationExistsEx:
   call denter
   MakeStack

   if used is64
      push (6*psize) ;MEMORY_BASIC_INFORMATION64
   else
      push (7*psize)
   end if
   call GetMemLocation
   mov pebx,peax

   if used is64
      mov r8,(6*psize) ;MEMORY_BASIC_INFORMATION64
   else
      push (7*psize)
   end if
   argpush 2,pebx    ;pointer to MEMORY_BASIC_INFORMATION64
   argpush 1,pdword [pebp+psize*2] ;address
   call [VirtualQuery]
   test peax,peax
   jz enddoesVMLocationExists

   mov eax,dword [pebx+psize*4] ;member state
   and eax,0x1000     ;if MEM_COMMIT
   jz enddoesVMLocationExists

   mov pecx,pdword [pebp+psize*4] ;return value size
   test pecx,pecx
   jz dontSetSizeParameter

   mov peax,pdword [pebx+psize*3] ;member RegionSize
   mov pdword [pecx],peax

   dontSetSizeParameter:
   mov eax,dword [pebx+(psize*4)+4] ;member protect

   ;First bit stands for NOACCES
   shr eax,1
   jc enddoesVMLocationExists

   mov ecx,eax
   xor eax,eax
   inc eax ;eax = RIGHT_READ

   ;next bit is READ_ONLY
   shr ecx,1
   jc enddoesVMLocationExists

   cmc ;CF != CF
   rcl eax,1 ;eax = RIGHT_READ |RIGHT_WRITE

   ;next bit is READWRITE
   shr ecx,1
   jc enddoesVMLocationExists

   ;next bit is WRITECOPY
   shr ecx,1
   jc enddoesVMLocationExists

   mov eax,0x4	;eax = RIGHT_EXECUTE

   ;next bit is PAGE_EXECUTE
   shr ecx,1
   jc enddoesVMLocationExists

   or eax,1 ;eax = RIGHT_EXECUTE  or  RIGHT_READ

   ;next bit is PAGE_EXECUTE_READ
   shr ecx,1
   jc enddoesVMLocationExists

   or eax,2 ;eax = RIGHT_EXECUTE  or  RIGHT_READ | RIGHT_WRITE

   ;next bit is PAGE_EXECUTE_READWRITE
   shr ecx,1
   jc enddoesVMLocationExists

   ;next bit is PAGE_EXECUTE_WRITECOPY
   shr ecx,1
   jc enddoesVMLocationExists

   xor eax,eax

   enddoesVMLocationExists:
   ;do and operation with the required rights, if result is zero it does not meet the required rights
   and eax,dword [pebp+psize*3]
   jz returndoesVMLocationExists

   xor ecx,ecx ;retv
   xchg eax,ecx

   ;check if all the rights where met.
   cmp ecx,dword [pebp+psize*3]
   jne returndoesVMLocationExists

   mov peax,pdword [pebp+psize*2] ;yes the VM does exists and has the required rights

   returndoesVMLocationExists:
   push peax

   ;free MEMORY_BASIC_INFORMATION64
   push pebx
   call FuncUnsafeFreeMemLocation

   pop peax

   call dleave
   ret psize*3
end if